lib/blog_web/router.ex
defmodule BlogWeb.Router do
  use BlogWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  scope "/", BlogWeb do
    pipe_through :browser

    get "/", PageController, :index
    resources "/registrations", UserController
    resources "/posts", PostController do
      resources "/comments", CommentController, only: [:create, :delete]
    end

    resources "/tags", TagController

    post "/post", PostController, :tag

    get "/sign-in", SessionController, :new
    post "/sign-in", SessionController, :create
    delete "/sign-out", SessionController, :delete

    # resources "/tags", TagController
  end

  # Other scopes may use custom stacks.
  # scope "/api", BlogWeb do
  #   pipe_through :api
  # end
end

lib/blog/content/post.ex
defmodule Blog.Content.Post do
  use Ecto.Schema
  import Ecto.Changeset

  alias Blog.Content.Tag

  schema "posts" do
    field :body, :string
    field :title, :string
    has_many :comments, Blog.Content.Comment
    many_to_many(
      :tags,
      Tag,
      join_through: "post_tags",
      on_replace: :delete
    )

    timestamps()
  end

  @doc false
  def changeset(post, attrs) do
    post
    |> cast(attrs, [:title, :body])
    |> validate_required([:title, :body])
  end
end

lib/blog_web/controllers/post_controller.ex
defmodule BlogWeb.PostController do
  use BlogWeb, :controller

  alias Blog.Content
  alias Blog.Content.{Post, Comment, Tag}

  def index(conn, _params) do
    posts = Content.list_posts()
    render(conn, "index.html", posts: posts)
  end

  def new(conn, _params) do
    changeset = Content.change_post(%Post{})
    tags = Content.list_tags()
    render(conn, "new.html", changeset: changeset, tags: tags)
  end

  def create(conn, %{"post" => post_params}) do
    case Content.create_post(post_params) do
      {:ok, post} ->
        conn
        |> put_flash(:info, "Post created successfully.")
        |> redirect(to: Routes.post_path(conn, :show, post))

      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  def show(conn, %{"id" => id}) do
    post = Content.get_post!(id)
    comment_changeset = Content.change_comment(%Comment{})
    tag_changeset = Content.change_tag(%Tag{})
    tags = Content.list_tags()
    render(conn, "show.html", post: post, comment_changeset: comment_changeset, tag_changeset: tag_changeset, tags: tags)
  end

  def edit(conn, %{"id" => id}) do
    post = Content.get_post!(id)
    changeset = Content.change_post(post)
    render(conn, "edit.html", post: post, changeset: changeset)
  end

  def update(conn, %{"id" => id, "post" => post_params}) do
    post = Content.get_post!(id)

    case Content.update_post(post, post_params) do
      {:ok, post} ->
        conn
        |> put_flash(:info, "Post updated successfully.")
        |> redirect(to: Routes.post_path(conn, :show, post))

      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "edit.html", post: post, changeset: changeset)
    end
  end

  def delete(conn, %{"id" => id}) do
    post = Content.get_post!(id)
    {:ok, _post} = Content.delete_post(post)

    conn
    |> put_flash(:info, "Post deleted successfully.")
    |> redirect(to: Routes.post_path(conn, :index))
  end

  def add(conn, _params) do
    tags = Content.list_tags
    render(conn, "add.html",tags: tags)
  end

  def tag(conn, %{ "post" => post_params}) do
    post_id = Map.get(post_params, "post_id")
    tag_id = Map.get(post_params, "tag_id")


    case Content.add_tag(post_id, tag_id) do
      {:ok,_} ->
        conn
        |> put_flash(:info, "Tags added successfully.")
        |> redirect(to: Routes.page_path(conn, :index))

      {:error, %Ecto.Changeset{} = changeset} ->
        conn
        |> put_flash(:info, "Memo already  sent to this user.")
        render conn, "new.html"
    end
  end
end

lib/blog_web/views/post_view.ex
defmodule BlogWeb.PostView do
  use BlogWeb, :view
end

lib/blog_web/templates/post/add.html.eex
<div class="columns">
    <div class="column col-7 col-mx-auto">
<h1>Add Tags</h1>

<%= form_for @changeset, @action, fn f -> %>
  <%= if @changeset.action do %>
    <div class="alert alert-danger">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

    <div class="form-group">
    <%= for tag <- @tags do %>
    <input id="tags" name="<%= tag.name %>" type="checkbox"><%= tag.name %>
    <% end %>
    </div>

    <br><div>
    <%= submit "Save", class: "btn" %>
  </div>
<% end %>

<div class="columns"><span class="column col-3 col-ml-auto"><%= link "Back", to: Routes.page_path(@conn, :index), class: "btn" %></span></div>
</div>
</div>

lib/blog_web/templates/post/edit.html.eex
<h1>Edit Post</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.post_path(@conn, :update, @post)) %>

<span><%= link "Back", to: Routes.post_path(@conn, :index) %></span>

lib/blog_web/templates/post/form.html.eex
<%= form_for @changeset, @action, fn f -> %>
  <%= if @changeset.action do %>
    <div class="alert alert-danger">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

  <%= label f, :title %>
  <%= text_input f, :title, class: "form-input" %>
  <%= error_tag f, :title %><br>

  <%= label f, :body %>
  <%= textarea f, :body, class: "form-input" %>
  <%= error_tag f, :body %><br>

  <%= label f, :tag %>
  <select id="tag_id" name="tags[id]" class="form-input">
    <%= for tag <- @tags do %>
    <option value="<%= tag.id %>"><%= tag.name %></option>
    <% end %>
  </select>

  

  <br><div>
    <%= submit "Save", class: "btn" %>
  </div>
<% end %>

lib/blog_web/templates/post/index.html.eex
<h1>Listing Posts</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Body</th>

      <th></th>
    </tr>
  </thead>
  <tbody>
<%= for post <- @posts do %>
    <tr>
      <td><%= post.title %></td>
      <td><%= post.body %></td>

      <td>
        <%= link "Show", to: Routes.post_path(@conn, :show, post) %>
        <%= link "Edit", to: Routes.post_path(@conn, :edit, post) %>
        <%= link "Delete", to: Routes.post_path(@conn, :delete, post), method: :delete, data: [confirm: "Are you sure?"] %>
      </td>
    </tr>
<% end %>
  </tbody>
</table>

<span><%= link "New Post", to: Routes.post_path(@conn, :new) %></span>

lib/blog_web/templates/post/new.html.eex
<div class="columns">
    <div class="column col-7 col-mx-auto">
<h1>New Post</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.post_path(@conn, :create)) %>

<div class="columns"><span class="column col-3 col-ml-auto"><%= link "Back", to: Routes.page_path(@conn, :index), class: "btn" %></span></div>
</div>
</div>

lib/blog_web/templates/post/show.html.eex
<div class="container">
  <div class="columns">
    <div class="column col-7 col-mx-auto">

      <div class="panel">
        <div class="panel-header">
          <div class="panel-title">
            <div class="blog_preview">
              <h3 class="title"><%= @post.title %></h3>
              <p class="body"><%= @post.body %></p>
              Tags: <small class="tag">
              <%= for tag <- @post.tags do %>
              <%= tag.name %>, 
              <% end %>
              </small>
            </div>
          </div>
        </div>
        <div class="panel-body">
          <div>
            <h5>Comments</h5>
                <%= for comment <- @post.comments do %>
                <div class="comment">
                <strong><%= comment.name %></strong>
                  <p><%= comment.body %></p>
                  <button class="btn btn-sm btn-error">Delete</button>
                  </div>
                <% end %>
          </div>
        </div>
        <div class="panel-footer">
          <div>
            <h5>Add a comment</h5>
            <%= form_for @comment_changeset, Routes.post_comment_path(@conn, :create, @post), fn f -> %>
              <%= label f, :name %>
              <%= text_input f, :name, class: "form-input" %>
              <%= error_tag f, :name %>

              <%= label f, :body %>
              <%= textarea f, :body, class: "form-input" %>
              <%= error_tag f, :body %><br>
              <div>
                <%= submit "Submit", class: "btn btn-success" %>
              </div>
            <% end %>
          </div>
          
          <div>
              <%= form_for @conn, "/posts",[as: :post], fn f -> %>
              <div class="input-group input-inline">
                <input class="form-input" id="tag_name" name="post[post_id]" type="hidden" placeholder="add tag">
                <select class="form-input" id="tag_name" name="post[tag_id]" placeholder="add tag"><option>Sales<option>
                </select>
                <%= error_tag f, :name %>
                <button class="btn btn-primary input-group-btn" type="submit">Add</button>
              </div>
              <% end %>
            </div>
        </div>
      </div>

      

      

      

    </div>

    

  </div>
</div>



<%# <span><%= link "Edit", to: Routes.post_path(@conn, :edit, @post) %>
<%# <span><%= link "Back", to: Routes.post_path(@conn, :index) %>

lib/blog_web/templates/post/tag.html.eex
<%= form_for @changeset, @action, fn f -> %>
  <%= if @changeset.action do %>
    <div class="alert alert-danger">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

    <div class="form-group">
    <%= for tag <- @tags do %>
    <input id="tags" name="<%= tag.name %>" type="checkbox"><%= tag.name %>
    <% end %>
    </div>

    <br><div>
    <%= submit "Save", class: "btn" %>
  </div>
<% end %>